
public abstract class Player {
    protected boolean myTurn;
    protected boolean isServer;
    protected boolean waitingForResponse;
    protected Player enemy;
    protected String name;
    protected Board board;

    public Player(int size) {
        this.board = new Board(size);
    }

    public synchronized void receiveShoot(Point point) {
        HitResponse hitResponse = board.getHitResponsOnPoint(point);
        if (!(hitResponse == null)){
            enemy.receiveHit(hitResponse);
        } else {
            enemy.receiveHit(this.board.hit(point));
        }
    }

    public synchronized void receiveHit(HitResponse hitResponse) {
        enemy.board.addHits(hitResponse);
    }

    public void click(Point point) {

    }

    public void beginTrun() {

    }

    public void setEnemy(Player enemy) {
        this.enemy = enemy;
    }
}
